// Code generated by SQLBoiler 4.14.2 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/friendsofgo/errors"
	"github.com/volatiletech/null/v8"
	"github.com/volatiletech/sqlboiler/v4/boil"
	"github.com/volatiletech/sqlboiler/v4/queries"
	"github.com/volatiletech/sqlboiler/v4/queries/qm"
	"github.com/volatiletech/sqlboiler/v4/queries/qmhelper"
	"github.com/volatiletech/strmangle"
)

// OrderGoal is an object representing the database table.
type OrderGoal struct {
	ID                int64       `boil:"id" json:"id" toml:"id" yaml:"id"`
	Note              null.String `boil:"note" json:"note,omitempty" toml:"note" yaml:"note,omitempty"`
	Miss              null.Int    `boil:"miss" json:"miss,omitempty" toml:"miss" yaml:"miss,omitempty"`
	PriceOld          null.Int    `boil:"price_old" json:"price_old,omitempty" toml:"price_old" yaml:"price_old,omitempty"`
	ProductName       null.String `boil:"product_name" json:"product_name,omitempty" toml:"product_name" yaml:"product_name,omitempty"`
	AddPayments       null.Int    `boil:"add_payments" json:"add_payments,omitempty" toml:"add_payments" yaml:"add_payments,omitempty"`
	Price             null.Int    `boil:"price" json:"price,omitempty" toml:"price" yaml:"price,omitempty"`
	OrderDate         null.Time   `boil:"order_date" json:"order_date,omitempty" toml:"order_date" yaml:"order_date,omitempty"`
	Percent           null.Int64  `boil:"percent" json:"percent,omitempty" toml:"percent" yaml:"percent,omitempty"`
	CustomerID        null.Int64  `boil:"customer_id" json:"customer_id,omitempty" toml:"customer_id" yaml:"customer_id,omitempty"`
	ReturnDate        null.Time   `boil:"return_date" json:"return_date,omitempty" toml:"return_date" yaml:"return_date,omitempty"`
	Status            null.String `boil:"status" json:"status,omitempty" toml:"status" yaml:"status,omitempty"`
	InterestPaidCount null.Int    `boil:"interest_paid_count" json:"interest_paid_count,omitempty" toml:"interest_paid_count" yaml:"interest_paid_count,omitempty"`
	CreatedAt         time.Time   `boil:"created_at" json:"created_at" toml:"created_at" yaml:"created_at"`
	UpdatedAt         time.Time   `boil:"updated_at" json:"updated_at" toml:"updated_at" yaml:"updated_at"`

	R *orderGoalR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L orderGoalL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var OrderGoalColumns = struct {
	ID                string
	Note              string
	Miss              string
	PriceOld          string
	ProductName       string
	AddPayments       string
	Price             string
	OrderDate         string
	Percent           string
	CustomerID        string
	ReturnDate        string
	Status            string
	InterestPaidCount string
	CreatedAt         string
	UpdatedAt         string
}{
	ID:                "id",
	Note:              "note",
	Miss:              "miss",
	PriceOld:          "price_old",
	ProductName:       "product_name",
	AddPayments:       "add_payments",
	Price:             "price",
	OrderDate:         "order_date",
	Percent:           "percent",
	CustomerID:        "customer_id",
	ReturnDate:        "return_date",
	Status:            "status",
	InterestPaidCount: "interest_paid_count",
	CreatedAt:         "created_at",
	UpdatedAt:         "updated_at",
}

var OrderGoalTableColumns = struct {
	ID                string
	Note              string
	Miss              string
	PriceOld          string
	ProductName       string
	AddPayments       string
	Price             string
	OrderDate         string
	Percent           string
	CustomerID        string
	ReturnDate        string
	Status            string
	InterestPaidCount string
	CreatedAt         string
	UpdatedAt         string
}{
	ID:                "order_goal.id",
	Note:              "order_goal.note",
	Miss:              "order_goal.miss",
	PriceOld:          "order_goal.price_old",
	ProductName:       "order_goal.product_name",
	AddPayments:       "order_goal.add_payments",
	Price:             "order_goal.price",
	OrderDate:         "order_goal.order_date",
	Percent:           "order_goal.percent",
	CustomerID:        "order_goal.customer_id",
	ReturnDate:        "order_goal.return_date",
	Status:            "order_goal.status",
	InterestPaidCount: "order_goal.interest_paid_count",
	CreatedAt:         "order_goal.created_at",
	UpdatedAt:         "order_goal.updated_at",
}

// Generated where

var OrderGoalWhere = struct {
	ID                whereHelperint64
	Note              whereHelpernull_String
	Miss              whereHelpernull_Int
	PriceOld          whereHelpernull_Int
	ProductName       whereHelpernull_String
	AddPayments       whereHelpernull_Int
	Price             whereHelpernull_Int
	OrderDate         whereHelpernull_Time
	Percent           whereHelpernull_Int64
	CustomerID        whereHelpernull_Int64
	ReturnDate        whereHelpernull_Time
	Status            whereHelpernull_String
	InterestPaidCount whereHelpernull_Int
	CreatedAt         whereHelpertime_Time
	UpdatedAt         whereHelpertime_Time
}{
	ID:                whereHelperint64{field: "\"order_goal\".\"id\""},
	Note:              whereHelpernull_String{field: "\"order_goal\".\"note\""},
	Miss:              whereHelpernull_Int{field: "\"order_goal\".\"miss\""},
	PriceOld:          whereHelpernull_Int{field: "\"order_goal\".\"price_old\""},
	ProductName:       whereHelpernull_String{field: "\"order_goal\".\"product_name\""},
	AddPayments:       whereHelpernull_Int{field: "\"order_goal\".\"add_payments\""},
	Price:             whereHelpernull_Int{field: "\"order_goal\".\"price\""},
	OrderDate:         whereHelpernull_Time{field: "\"order_goal\".\"order_date\""},
	Percent:           whereHelpernull_Int64{field: "\"order_goal\".\"percent\""},
	CustomerID:        whereHelpernull_Int64{field: "\"order_goal\".\"customer_id\""},
	ReturnDate:        whereHelpernull_Time{field: "\"order_goal\".\"return_date\""},
	Status:            whereHelpernull_String{field: "\"order_goal\".\"status\""},
	InterestPaidCount: whereHelpernull_Int{field: "\"order_goal\".\"interest_paid_count\""},
	CreatedAt:         whereHelpertime_Time{field: "\"order_goal\".\"created_at\""},
	UpdatedAt:         whereHelpertime_Time{field: "\"order_goal\".\"updated_at\""},
}

// OrderGoalRels is where relationship names are stored.
var OrderGoalRels = struct {
	Customer                   string
	PercentCategoryPercent     string
	IDGoldAddPaymentsGoals     string
	OrderInterestPaymentsGoals string
	IDGoalProductGolds         string
	OrderRedeemOrderGoals      string
}{
	Customer:                   "Customer",
	PercentCategoryPercent:     "PercentCategoryPercent",
	IDGoldAddPaymentsGoals:     "IDGoldAddPaymentsGoals",
	OrderInterestPaymentsGoals: "OrderInterestPaymentsGoals",
	IDGoalProductGolds:         "IDGoalProductGolds",
	OrderRedeemOrderGoals:      "OrderRedeemOrderGoals",
}

// orderGoalR is where relationships are stored.
type orderGoalR struct {
	Customer                   *Customer                 `boil:"Customer" json:"Customer" toml:"Customer" yaml:"Customer"`
	PercentCategoryPercent     *CategoryPercent          `boil:"PercentCategoryPercent" json:"PercentCategoryPercent" toml:"PercentCategoryPercent" yaml:"PercentCategoryPercent"`
	IDGoldAddPaymentsGoals     AddPaymentsGoalSlice      `boil:"IDGoldAddPaymentsGoals" json:"IDGoldAddPaymentsGoals" toml:"IDGoldAddPaymentsGoals" yaml:"IDGoldAddPaymentsGoals"`
	OrderInterestPaymentsGoals InterestPaymentsGoalSlice `boil:"OrderInterestPaymentsGoals" json:"OrderInterestPaymentsGoals" toml:"OrderInterestPaymentsGoals" yaml:"OrderInterestPaymentsGoals"`
	IDGoalProductGolds         ProductGoldSlice          `boil:"IDGoalProductGolds" json:"IDGoalProductGolds" toml:"IDGoalProductGolds" yaml:"IDGoalProductGolds"`
	OrderRedeemOrderGoals      RedeemOrderGoalSlice      `boil:"OrderRedeemOrderGoals" json:"OrderRedeemOrderGoals" toml:"OrderRedeemOrderGoals" yaml:"OrderRedeemOrderGoals"`
}

// NewStruct creates a new relationship struct
func (*orderGoalR) NewStruct() *orderGoalR {
	return &orderGoalR{}
}

func (r *orderGoalR) GetCustomer() *Customer {
	if r == nil {
		return nil
	}
	return r.Customer
}

func (r *orderGoalR) GetPercentCategoryPercent() *CategoryPercent {
	if r == nil {
		return nil
	}
	return r.PercentCategoryPercent
}

func (r *orderGoalR) GetIDGoldAddPaymentsGoals() AddPaymentsGoalSlice {
	if r == nil {
		return nil
	}
	return r.IDGoldAddPaymentsGoals
}

func (r *orderGoalR) GetOrderInterestPaymentsGoals() InterestPaymentsGoalSlice {
	if r == nil {
		return nil
	}
	return r.OrderInterestPaymentsGoals
}

func (r *orderGoalR) GetIDGoalProductGolds() ProductGoldSlice {
	if r == nil {
		return nil
	}
	return r.IDGoalProductGolds
}

func (r *orderGoalR) GetOrderRedeemOrderGoals() RedeemOrderGoalSlice {
	if r == nil {
		return nil
	}
	return r.OrderRedeemOrderGoals
}

// orderGoalL is where Load methods for each relationship are stored.
type orderGoalL struct{}

var (
	orderGoalAllColumns            = []string{"id", "note", "miss", "price_old", "product_name", "add_payments", "price", "order_date", "percent", "customer_id", "return_date", "status", "interest_paid_count", "created_at", "updated_at"}
	orderGoalColumnsWithoutDefault = []string{}
	orderGoalColumnsWithDefault    = []string{"id", "note", "miss", "price_old", "product_name", "add_payments", "price", "order_date", "percent", "customer_id", "return_date", "status", "interest_paid_count", "created_at", "updated_at"}
	orderGoalPrimaryKeyColumns     = []string{"id"}
	orderGoalGeneratedColumns      = []string{}
)

type (
	// OrderGoalSlice is an alias for a slice of pointers to OrderGoal.
	// This should almost always be used instead of []OrderGoal.
	OrderGoalSlice []*OrderGoal
	// OrderGoalHook is the signature for custom OrderGoal hook methods
	OrderGoalHook func(context.Context, boil.ContextExecutor, *OrderGoal) error

	orderGoalQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	orderGoalType                 = reflect.TypeOf(&OrderGoal{})
	orderGoalMapping              = queries.MakeStructMapping(orderGoalType)
	orderGoalPrimaryKeyMapping, _ = queries.BindMapping(orderGoalType, orderGoalMapping, orderGoalPrimaryKeyColumns)
	orderGoalInsertCacheMut       sync.RWMutex
	orderGoalInsertCache          = make(map[string]insertCache)
	orderGoalUpdateCacheMut       sync.RWMutex
	orderGoalUpdateCache          = make(map[string]updateCache)
	orderGoalUpsertCacheMut       sync.RWMutex
	orderGoalUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var orderGoalAfterSelectHooks []OrderGoalHook

var orderGoalBeforeInsertHooks []OrderGoalHook
var orderGoalAfterInsertHooks []OrderGoalHook

var orderGoalBeforeUpdateHooks []OrderGoalHook
var orderGoalAfterUpdateHooks []OrderGoalHook

var orderGoalBeforeDeleteHooks []OrderGoalHook
var orderGoalAfterDeleteHooks []OrderGoalHook

var orderGoalBeforeUpsertHooks []OrderGoalHook
var orderGoalAfterUpsertHooks []OrderGoalHook

// doAfterSelectHooks executes all "after Select" hooks.
func (o *OrderGoal) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderGoalAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *OrderGoal) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderGoalBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *OrderGoal) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderGoalAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *OrderGoal) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderGoalBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *OrderGoal) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderGoalAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *OrderGoal) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderGoalBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *OrderGoal) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderGoalAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *OrderGoal) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderGoalBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *OrderGoal) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderGoalAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddOrderGoalHook registers your hook function for all future operations.
func AddOrderGoalHook(hookPoint boil.HookPoint, orderGoalHook OrderGoalHook) {
	switch hookPoint {
	case boil.AfterSelectHook:
		orderGoalAfterSelectHooks = append(orderGoalAfterSelectHooks, orderGoalHook)
	case boil.BeforeInsertHook:
		orderGoalBeforeInsertHooks = append(orderGoalBeforeInsertHooks, orderGoalHook)
	case boil.AfterInsertHook:
		orderGoalAfterInsertHooks = append(orderGoalAfterInsertHooks, orderGoalHook)
	case boil.BeforeUpdateHook:
		orderGoalBeforeUpdateHooks = append(orderGoalBeforeUpdateHooks, orderGoalHook)
	case boil.AfterUpdateHook:
		orderGoalAfterUpdateHooks = append(orderGoalAfterUpdateHooks, orderGoalHook)
	case boil.BeforeDeleteHook:
		orderGoalBeforeDeleteHooks = append(orderGoalBeforeDeleteHooks, orderGoalHook)
	case boil.AfterDeleteHook:
		orderGoalAfterDeleteHooks = append(orderGoalAfterDeleteHooks, orderGoalHook)
	case boil.BeforeUpsertHook:
		orderGoalBeforeUpsertHooks = append(orderGoalBeforeUpsertHooks, orderGoalHook)
	case boil.AfterUpsertHook:
		orderGoalAfterUpsertHooks = append(orderGoalAfterUpsertHooks, orderGoalHook)
	}
}

// One returns a single orderGoal record from the query.
func (q orderGoalQuery) One(ctx context.Context, exec boil.ContextExecutor) (*OrderGoal, error) {
	o := &OrderGoal{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: failed to execute a one query for order_goal")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all OrderGoal records from the query.
func (q orderGoalQuery) All(ctx context.Context, exec boil.ContextExecutor) (OrderGoalSlice, error) {
	var o []*OrderGoal

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "models: failed to assign all query results to OrderGoal slice")
	}

	if len(orderGoalAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all OrderGoal records in the query.
func (q orderGoalQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to count order_goal rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q orderGoalQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "models: failed to check if order_goal exists")
	}

	return count > 0, nil
}

// Customer pointed to by the foreign key.
func (o *OrderGoal) Customer(mods ...qm.QueryMod) customerQuery {
	queryMods := []qm.QueryMod{
		qm.Where("\"customer_id\" = ?", o.CustomerID),
	}

	queryMods = append(queryMods, mods...)

	return Customers(queryMods...)
}

// PercentCategoryPercent pointed to by the foreign key.
func (o *OrderGoal) PercentCategoryPercent(mods ...qm.QueryMod) categoryPercentQuery {
	queryMods := []qm.QueryMod{
		qm.Where("\"percent_id\" = ?", o.Percent),
	}

	queryMods = append(queryMods, mods...)

	return CategoryPercents(queryMods...)
}

// IDGoldAddPaymentsGoals retrieves all the add_payments_goal's AddPaymentsGoals with an executor via id_gold column.
func (o *OrderGoal) IDGoldAddPaymentsGoals(mods ...qm.QueryMod) addPaymentsGoalQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"add_payments_goal\".\"id_gold\"=?", o.ID),
	)

	return AddPaymentsGoals(queryMods...)
}

// OrderInterestPaymentsGoals retrieves all the interest_payments_goal's InterestPaymentsGoals with an executor via order_id column.
func (o *OrderGoal) OrderInterestPaymentsGoals(mods ...qm.QueryMod) interestPaymentsGoalQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"interest_payments_goal\".\"order_id\"=?", o.ID),
	)

	return InterestPaymentsGoals(queryMods...)
}

// IDGoalProductGolds retrieves all the product_gold's ProductGolds with an executor via id_goal column.
func (o *OrderGoal) IDGoalProductGolds(mods ...qm.QueryMod) productGoldQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"product_gold\".\"id_goal\"=?", o.ID),
	)

	return ProductGolds(queryMods...)
}

// OrderRedeemOrderGoals retrieves all the redeem_order_goal's RedeemOrderGoals with an executor via order_id column.
func (o *OrderGoal) OrderRedeemOrderGoals(mods ...qm.QueryMod) redeemOrderGoalQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"redeem_order_goal\".\"order_id\"=?", o.ID),
	)

	return RedeemOrderGoals(queryMods...)
}

// LoadCustomer allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (orderGoalL) LoadCustomer(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderGoal interface{}, mods queries.Applicator) error {
	var slice []*OrderGoal
	var object *OrderGoal

	if singular {
		var ok bool
		object, ok = maybeOrderGoal.(*OrderGoal)
		if !ok {
			object = new(OrderGoal)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeOrderGoal))
			}
		}
	} else {
		s, ok := maybeOrderGoal.(*[]*OrderGoal)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeOrderGoal))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderGoalR{}
		}
		if !queries.IsNil(object.CustomerID) {
			args = append(args, object.CustomerID)
		}

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderGoalR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.CustomerID) {
					continue Outer
				}
			}

			if !queries.IsNil(obj.CustomerID) {
				args = append(args, obj.CustomerID)
			}

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`customers`),
		qm.WhereIn(`customers.customer_id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load Customer")
	}

	var resultSlice []*Customer
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice Customer")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for customers")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for customers")
	}

	if len(customerAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.Customer = foreign
		if foreign.R == nil {
			foreign.R = &customerR{}
		}
		foreign.R.OrderGoals = append(foreign.R.OrderGoals, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if queries.Equal(local.CustomerID, foreign.CustomerID) {
				local.R.Customer = foreign
				if foreign.R == nil {
					foreign.R = &customerR{}
				}
				foreign.R.OrderGoals = append(foreign.R.OrderGoals, local)
				break
			}
		}
	}

	return nil
}

// LoadPercentCategoryPercent allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (orderGoalL) LoadPercentCategoryPercent(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderGoal interface{}, mods queries.Applicator) error {
	var slice []*OrderGoal
	var object *OrderGoal

	if singular {
		var ok bool
		object, ok = maybeOrderGoal.(*OrderGoal)
		if !ok {
			object = new(OrderGoal)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeOrderGoal))
			}
		}
	} else {
		s, ok := maybeOrderGoal.(*[]*OrderGoal)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeOrderGoal))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderGoalR{}
		}
		if !queries.IsNil(object.Percent) {
			args = append(args, object.Percent)
		}

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderGoalR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.Percent) {
					continue Outer
				}
			}

			if !queries.IsNil(obj.Percent) {
				args = append(args, obj.Percent)
			}

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`category_percent`),
		qm.WhereIn(`category_percent.percent_id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load CategoryPercent")
	}

	var resultSlice []*CategoryPercent
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice CategoryPercent")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for category_percent")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for category_percent")
	}

	if len(categoryPercentAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.PercentCategoryPercent = foreign
		if foreign.R == nil {
			foreign.R = &categoryPercentR{}
		}
		foreign.R.PercentOrderGoals = append(foreign.R.PercentOrderGoals, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if queries.Equal(local.Percent, foreign.PercentID) {
				local.R.PercentCategoryPercent = foreign
				if foreign.R == nil {
					foreign.R = &categoryPercentR{}
				}
				foreign.R.PercentOrderGoals = append(foreign.R.PercentOrderGoals, local)
				break
			}
		}
	}

	return nil
}

// LoadIDGoldAddPaymentsGoals allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (orderGoalL) LoadIDGoldAddPaymentsGoals(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderGoal interface{}, mods queries.Applicator) error {
	var slice []*OrderGoal
	var object *OrderGoal

	if singular {
		var ok bool
		object, ok = maybeOrderGoal.(*OrderGoal)
		if !ok {
			object = new(OrderGoal)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeOrderGoal))
			}
		}
	} else {
		s, ok := maybeOrderGoal.(*[]*OrderGoal)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeOrderGoal))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderGoalR{}
		}
		args = append(args, object.ID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderGoalR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.ID) {
					continue Outer
				}
			}

			args = append(args, obj.ID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`add_payments_goal`),
		qm.WhereIn(`add_payments_goal.id_gold in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load add_payments_goal")
	}

	var resultSlice []*AddPaymentsGoal
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice add_payments_goal")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on add_payments_goal")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for add_payments_goal")
	}

	if len(addPaymentsGoalAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.IDGoldAddPaymentsGoals = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &addPaymentsGoalR{}
			}
			foreign.R.IDGoldOrderGoal = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if queries.Equal(local.ID, foreign.IDGold) {
				local.R.IDGoldAddPaymentsGoals = append(local.R.IDGoldAddPaymentsGoals, foreign)
				if foreign.R == nil {
					foreign.R = &addPaymentsGoalR{}
				}
				foreign.R.IDGoldOrderGoal = local
				break
			}
		}
	}

	return nil
}

// LoadOrderInterestPaymentsGoals allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (orderGoalL) LoadOrderInterestPaymentsGoals(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderGoal interface{}, mods queries.Applicator) error {
	var slice []*OrderGoal
	var object *OrderGoal

	if singular {
		var ok bool
		object, ok = maybeOrderGoal.(*OrderGoal)
		if !ok {
			object = new(OrderGoal)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeOrderGoal))
			}
		}
	} else {
		s, ok := maybeOrderGoal.(*[]*OrderGoal)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeOrderGoal))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderGoalR{}
		}
		args = append(args, object.ID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderGoalR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.ID) {
					continue Outer
				}
			}

			args = append(args, obj.ID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`interest_payments_goal`),
		qm.WhereIn(`interest_payments_goal.order_id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load interest_payments_goal")
	}

	var resultSlice []*InterestPaymentsGoal
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice interest_payments_goal")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on interest_payments_goal")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for interest_payments_goal")
	}

	if len(interestPaymentsGoalAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.OrderInterestPaymentsGoals = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &interestPaymentsGoalR{}
			}
			foreign.R.Order = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if queries.Equal(local.ID, foreign.OrderID) {
				local.R.OrderInterestPaymentsGoals = append(local.R.OrderInterestPaymentsGoals, foreign)
				if foreign.R == nil {
					foreign.R = &interestPaymentsGoalR{}
				}
				foreign.R.Order = local
				break
			}
		}
	}

	return nil
}

// LoadIDGoalProductGolds allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (orderGoalL) LoadIDGoalProductGolds(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderGoal interface{}, mods queries.Applicator) error {
	var slice []*OrderGoal
	var object *OrderGoal

	if singular {
		var ok bool
		object, ok = maybeOrderGoal.(*OrderGoal)
		if !ok {
			object = new(OrderGoal)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeOrderGoal))
			}
		}
	} else {
		s, ok := maybeOrderGoal.(*[]*OrderGoal)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeOrderGoal))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderGoalR{}
		}
		args = append(args, object.ID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderGoalR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.ID) {
					continue Outer
				}
			}

			args = append(args, obj.ID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`product_gold`),
		qm.WhereIn(`product_gold.id_goal in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load product_gold")
	}

	var resultSlice []*ProductGold
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice product_gold")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on product_gold")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for product_gold")
	}

	if len(productGoldAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.IDGoalProductGolds = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &productGoldR{}
			}
			foreign.R.IDGoalOrderGoal = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if queries.Equal(local.ID, foreign.IDGoal) {
				local.R.IDGoalProductGolds = append(local.R.IDGoalProductGolds, foreign)
				if foreign.R == nil {
					foreign.R = &productGoldR{}
				}
				foreign.R.IDGoalOrderGoal = local
				break
			}
		}
	}

	return nil
}

// LoadOrderRedeemOrderGoals allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (orderGoalL) LoadOrderRedeemOrderGoals(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderGoal interface{}, mods queries.Applicator) error {
	var slice []*OrderGoal
	var object *OrderGoal

	if singular {
		var ok bool
		object, ok = maybeOrderGoal.(*OrderGoal)
		if !ok {
			object = new(OrderGoal)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeOrderGoal))
			}
		}
	} else {
		s, ok := maybeOrderGoal.(*[]*OrderGoal)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeOrderGoal))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderGoalR{}
		}
		args = append(args, object.ID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderGoalR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.ID) {
					continue Outer
				}
			}

			args = append(args, obj.ID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`redeem_order_goal`),
		qm.WhereIn(`redeem_order_goal.order_id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load redeem_order_goal")
	}

	var resultSlice []*RedeemOrderGoal
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice redeem_order_goal")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on redeem_order_goal")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for redeem_order_goal")
	}

	if len(redeemOrderGoalAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.OrderRedeemOrderGoals = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &redeemOrderGoalR{}
			}
			foreign.R.Order = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if queries.Equal(local.ID, foreign.OrderID) {
				local.R.OrderRedeemOrderGoals = append(local.R.OrderRedeemOrderGoals, foreign)
				if foreign.R == nil {
					foreign.R = &redeemOrderGoalR{}
				}
				foreign.R.Order = local
				break
			}
		}
	}

	return nil
}

// SetCustomer of the orderGoal to the related item.
// Sets o.R.Customer to related.
// Adds o to related.R.OrderGoals.
func (o *OrderGoal) SetCustomer(ctx context.Context, exec boil.ContextExecutor, insert bool, related *Customer) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"order_goal\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"customer_id"}),
		strmangle.WhereClause("\"", "\"", 2, orderGoalPrimaryKeyColumns),
	)
	values := []interface{}{related.CustomerID, o.ID}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, updateQuery)
		fmt.Fprintln(writer, values)
	}
	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	queries.Assign(&o.CustomerID, related.CustomerID)
	if o.R == nil {
		o.R = &orderGoalR{
			Customer: related,
		}
	} else {
		o.R.Customer = related
	}

	if related.R == nil {
		related.R = &customerR{
			OrderGoals: OrderGoalSlice{o},
		}
	} else {
		related.R.OrderGoals = append(related.R.OrderGoals, o)
	}

	return nil
}

// RemoveCustomer relationship.
// Sets o.R.Customer to nil.
// Removes o from all passed in related items' relationships struct.
func (o *OrderGoal) RemoveCustomer(ctx context.Context, exec boil.ContextExecutor, related *Customer) error {
	var err error

	queries.SetScanner(&o.CustomerID, nil)
	if _, err = o.Update(ctx, exec, boil.Whitelist("customer_id")); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	if o.R != nil {
		o.R.Customer = nil
	}
	if related == nil || related.R == nil {
		return nil
	}

	for i, ri := range related.R.OrderGoals {
		if queries.Equal(o.CustomerID, ri.CustomerID) {
			continue
		}

		ln := len(related.R.OrderGoals)
		if ln > 1 && i < ln-1 {
			related.R.OrderGoals[i] = related.R.OrderGoals[ln-1]
		}
		related.R.OrderGoals = related.R.OrderGoals[:ln-1]
		break
	}
	return nil
}

// SetPercentCategoryPercent of the orderGoal to the related item.
// Sets o.R.PercentCategoryPercent to related.
// Adds o to related.R.PercentOrderGoals.
func (o *OrderGoal) SetPercentCategoryPercent(ctx context.Context, exec boil.ContextExecutor, insert bool, related *CategoryPercent) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"order_goal\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"percent"}),
		strmangle.WhereClause("\"", "\"", 2, orderGoalPrimaryKeyColumns),
	)
	values := []interface{}{related.PercentID, o.ID}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, updateQuery)
		fmt.Fprintln(writer, values)
	}
	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	queries.Assign(&o.Percent, related.PercentID)
	if o.R == nil {
		o.R = &orderGoalR{
			PercentCategoryPercent: related,
		}
	} else {
		o.R.PercentCategoryPercent = related
	}

	if related.R == nil {
		related.R = &categoryPercentR{
			PercentOrderGoals: OrderGoalSlice{o},
		}
	} else {
		related.R.PercentOrderGoals = append(related.R.PercentOrderGoals, o)
	}

	return nil
}

// RemovePercentCategoryPercent relationship.
// Sets o.R.PercentCategoryPercent to nil.
// Removes o from all passed in related items' relationships struct.
func (o *OrderGoal) RemovePercentCategoryPercent(ctx context.Context, exec boil.ContextExecutor, related *CategoryPercent) error {
	var err error

	queries.SetScanner(&o.Percent, nil)
	if _, err = o.Update(ctx, exec, boil.Whitelist("percent")); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	if o.R != nil {
		o.R.PercentCategoryPercent = nil
	}
	if related == nil || related.R == nil {
		return nil
	}

	for i, ri := range related.R.PercentOrderGoals {
		if queries.Equal(o.Percent, ri.Percent) {
			continue
		}

		ln := len(related.R.PercentOrderGoals)
		if ln > 1 && i < ln-1 {
			related.R.PercentOrderGoals[i] = related.R.PercentOrderGoals[ln-1]
		}
		related.R.PercentOrderGoals = related.R.PercentOrderGoals[:ln-1]
		break
	}
	return nil
}

// AddIDGoldAddPaymentsGoals adds the given related objects to the existing relationships
// of the order_goal, optionally inserting them as new records.
// Appends related to o.R.IDGoldAddPaymentsGoals.
// Sets related.R.IDGoldOrderGoal appropriately.
func (o *OrderGoal) AddIDGoldAddPaymentsGoals(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*AddPaymentsGoal) error {
	var err error
	for _, rel := range related {
		if insert {
			queries.Assign(&rel.IDGold, o.ID)
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"add_payments_goal\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"id_gold"}),
				strmangle.WhereClause("\"", "\"", 2, addPaymentsGoalPrimaryKeyColumns),
			)
			values := []interface{}{o.ID, rel.ID}

			if boil.IsDebug(ctx) {
				writer := boil.DebugWriterFrom(ctx)
				fmt.Fprintln(writer, updateQuery)
				fmt.Fprintln(writer, values)
			}
			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			queries.Assign(&rel.IDGold, o.ID)
		}
	}

	if o.R == nil {
		o.R = &orderGoalR{
			IDGoldAddPaymentsGoals: related,
		}
	} else {
		o.R.IDGoldAddPaymentsGoals = append(o.R.IDGoldAddPaymentsGoals, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &addPaymentsGoalR{
				IDGoldOrderGoal: o,
			}
		} else {
			rel.R.IDGoldOrderGoal = o
		}
	}
	return nil
}

// SetIDGoldAddPaymentsGoals removes all previously related items of the
// order_goal replacing them completely with the passed
// in related items, optionally inserting them as new records.
// Sets o.R.IDGoldOrderGoal's IDGoldAddPaymentsGoals accordingly.
// Replaces o.R.IDGoldAddPaymentsGoals with related.
// Sets related.R.IDGoldOrderGoal's IDGoldAddPaymentsGoals accordingly.
func (o *OrderGoal) SetIDGoldAddPaymentsGoals(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*AddPaymentsGoal) error {
	query := "update \"add_payments_goal\" set \"id_gold\" = null where \"id_gold\" = $1"
	values := []interface{}{o.ID}
	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, query)
		fmt.Fprintln(writer, values)
	}
	_, err := exec.ExecContext(ctx, query, values...)
	if err != nil {
		return errors.Wrap(err, "failed to remove relationships before set")
	}

	if o.R != nil {
		for _, rel := range o.R.IDGoldAddPaymentsGoals {
			queries.SetScanner(&rel.IDGold, nil)
			if rel.R == nil {
				continue
			}

			rel.R.IDGoldOrderGoal = nil
		}
		o.R.IDGoldAddPaymentsGoals = nil
	}

	return o.AddIDGoldAddPaymentsGoals(ctx, exec, insert, related...)
}

// RemoveIDGoldAddPaymentsGoals relationships from objects passed in.
// Removes related items from R.IDGoldAddPaymentsGoals (uses pointer comparison, removal does not keep order)
// Sets related.R.IDGoldOrderGoal.
func (o *OrderGoal) RemoveIDGoldAddPaymentsGoals(ctx context.Context, exec boil.ContextExecutor, related ...*AddPaymentsGoal) error {
	if len(related) == 0 {
		return nil
	}

	var err error
	for _, rel := range related {
		queries.SetScanner(&rel.IDGold, nil)
		if rel.R != nil {
			rel.R.IDGoldOrderGoal = nil
		}
		if _, err = rel.Update(ctx, exec, boil.Whitelist("id_gold")); err != nil {
			return err
		}
	}
	if o.R == nil {
		return nil
	}

	for _, rel := range related {
		for i, ri := range o.R.IDGoldAddPaymentsGoals {
			if rel != ri {
				continue
			}

			ln := len(o.R.IDGoldAddPaymentsGoals)
			if ln > 1 && i < ln-1 {
				o.R.IDGoldAddPaymentsGoals[i] = o.R.IDGoldAddPaymentsGoals[ln-1]
			}
			o.R.IDGoldAddPaymentsGoals = o.R.IDGoldAddPaymentsGoals[:ln-1]
			break
		}
	}

	return nil
}

// AddOrderInterestPaymentsGoals adds the given related objects to the existing relationships
// of the order_goal, optionally inserting them as new records.
// Appends related to o.R.OrderInterestPaymentsGoals.
// Sets related.R.Order appropriately.
func (o *OrderGoal) AddOrderInterestPaymentsGoals(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*InterestPaymentsGoal) error {
	var err error
	for _, rel := range related {
		if insert {
			queries.Assign(&rel.OrderID, o.ID)
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"interest_payments_goal\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"order_id"}),
				strmangle.WhereClause("\"", "\"", 2, interestPaymentsGoalPrimaryKeyColumns),
			)
			values := []interface{}{o.ID, rel.PaymentID}

			if boil.IsDebug(ctx) {
				writer := boil.DebugWriterFrom(ctx)
				fmt.Fprintln(writer, updateQuery)
				fmt.Fprintln(writer, values)
			}
			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			queries.Assign(&rel.OrderID, o.ID)
		}
	}

	if o.R == nil {
		o.R = &orderGoalR{
			OrderInterestPaymentsGoals: related,
		}
	} else {
		o.R.OrderInterestPaymentsGoals = append(o.R.OrderInterestPaymentsGoals, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &interestPaymentsGoalR{
				Order: o,
			}
		} else {
			rel.R.Order = o
		}
	}
	return nil
}

// SetOrderInterestPaymentsGoals removes all previously related items of the
// order_goal replacing them completely with the passed
// in related items, optionally inserting them as new records.
// Sets o.R.Order's OrderInterestPaymentsGoals accordingly.
// Replaces o.R.OrderInterestPaymentsGoals with related.
// Sets related.R.Order's OrderInterestPaymentsGoals accordingly.
func (o *OrderGoal) SetOrderInterestPaymentsGoals(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*InterestPaymentsGoal) error {
	query := "update \"interest_payments_goal\" set \"order_id\" = null where \"order_id\" = $1"
	values := []interface{}{o.ID}
	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, query)
		fmt.Fprintln(writer, values)
	}
	_, err := exec.ExecContext(ctx, query, values...)
	if err != nil {
		return errors.Wrap(err, "failed to remove relationships before set")
	}

	if o.R != nil {
		for _, rel := range o.R.OrderInterestPaymentsGoals {
			queries.SetScanner(&rel.OrderID, nil)
			if rel.R == nil {
				continue
			}

			rel.R.Order = nil
		}
		o.R.OrderInterestPaymentsGoals = nil
	}

	return o.AddOrderInterestPaymentsGoals(ctx, exec, insert, related...)
}

// RemoveOrderInterestPaymentsGoals relationships from objects passed in.
// Removes related items from R.OrderInterestPaymentsGoals (uses pointer comparison, removal does not keep order)
// Sets related.R.Order.
func (o *OrderGoal) RemoveOrderInterestPaymentsGoals(ctx context.Context, exec boil.ContextExecutor, related ...*InterestPaymentsGoal) error {
	if len(related) == 0 {
		return nil
	}

	var err error
	for _, rel := range related {
		queries.SetScanner(&rel.OrderID, nil)
		if rel.R != nil {
			rel.R.Order = nil
		}
		if _, err = rel.Update(ctx, exec, boil.Whitelist("order_id")); err != nil {
			return err
		}
	}
	if o.R == nil {
		return nil
	}

	for _, rel := range related {
		for i, ri := range o.R.OrderInterestPaymentsGoals {
			if rel != ri {
				continue
			}

			ln := len(o.R.OrderInterestPaymentsGoals)
			if ln > 1 && i < ln-1 {
				o.R.OrderInterestPaymentsGoals[i] = o.R.OrderInterestPaymentsGoals[ln-1]
			}
			o.R.OrderInterestPaymentsGoals = o.R.OrderInterestPaymentsGoals[:ln-1]
			break
		}
	}

	return nil
}

// AddIDGoalProductGolds adds the given related objects to the existing relationships
// of the order_goal, optionally inserting them as new records.
// Appends related to o.R.IDGoalProductGolds.
// Sets related.R.IDGoalOrderGoal appropriately.
func (o *OrderGoal) AddIDGoalProductGolds(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*ProductGold) error {
	var err error
	for _, rel := range related {
		if insert {
			queries.Assign(&rel.IDGoal, o.ID)
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"product_gold\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"id_goal"}),
				strmangle.WhereClause("\"", "\"", 2, productGoldPrimaryKeyColumns),
			)
			values := []interface{}{o.ID, rel.ID}

			if boil.IsDebug(ctx) {
				writer := boil.DebugWriterFrom(ctx)
				fmt.Fprintln(writer, updateQuery)
				fmt.Fprintln(writer, values)
			}
			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			queries.Assign(&rel.IDGoal, o.ID)
		}
	}

	if o.R == nil {
		o.R = &orderGoalR{
			IDGoalProductGolds: related,
		}
	} else {
		o.R.IDGoalProductGolds = append(o.R.IDGoalProductGolds, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &productGoldR{
				IDGoalOrderGoal: o,
			}
		} else {
			rel.R.IDGoalOrderGoal = o
		}
	}
	return nil
}

// SetIDGoalProductGolds removes all previously related items of the
// order_goal replacing them completely with the passed
// in related items, optionally inserting them as new records.
// Sets o.R.IDGoalOrderGoal's IDGoalProductGolds accordingly.
// Replaces o.R.IDGoalProductGolds with related.
// Sets related.R.IDGoalOrderGoal's IDGoalProductGolds accordingly.
func (o *OrderGoal) SetIDGoalProductGolds(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*ProductGold) error {
	query := "update \"product_gold\" set \"id_goal\" = null where \"id_goal\" = $1"
	values := []interface{}{o.ID}
	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, query)
		fmt.Fprintln(writer, values)
	}
	_, err := exec.ExecContext(ctx, query, values...)
	if err != nil {
		return errors.Wrap(err, "failed to remove relationships before set")
	}

	if o.R != nil {
		for _, rel := range o.R.IDGoalProductGolds {
			queries.SetScanner(&rel.IDGoal, nil)
			if rel.R == nil {
				continue
			}

			rel.R.IDGoalOrderGoal = nil
		}
		o.R.IDGoalProductGolds = nil
	}

	return o.AddIDGoalProductGolds(ctx, exec, insert, related...)
}

// RemoveIDGoalProductGolds relationships from objects passed in.
// Removes related items from R.IDGoalProductGolds (uses pointer comparison, removal does not keep order)
// Sets related.R.IDGoalOrderGoal.
func (o *OrderGoal) RemoveIDGoalProductGolds(ctx context.Context, exec boil.ContextExecutor, related ...*ProductGold) error {
	if len(related) == 0 {
		return nil
	}

	var err error
	for _, rel := range related {
		queries.SetScanner(&rel.IDGoal, nil)
		if rel.R != nil {
			rel.R.IDGoalOrderGoal = nil
		}
		if _, err = rel.Update(ctx, exec, boil.Whitelist("id_goal")); err != nil {
			return err
		}
	}
	if o.R == nil {
		return nil
	}

	for _, rel := range related {
		for i, ri := range o.R.IDGoalProductGolds {
			if rel != ri {
				continue
			}

			ln := len(o.R.IDGoalProductGolds)
			if ln > 1 && i < ln-1 {
				o.R.IDGoalProductGolds[i] = o.R.IDGoalProductGolds[ln-1]
			}
			o.R.IDGoalProductGolds = o.R.IDGoalProductGolds[:ln-1]
			break
		}
	}

	return nil
}

// AddOrderRedeemOrderGoals adds the given related objects to the existing relationships
// of the order_goal, optionally inserting them as new records.
// Appends related to o.R.OrderRedeemOrderGoals.
// Sets related.R.Order appropriately.
func (o *OrderGoal) AddOrderRedeemOrderGoals(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*RedeemOrderGoal) error {
	var err error
	for _, rel := range related {
		if insert {
			queries.Assign(&rel.OrderID, o.ID)
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"redeem_order_goal\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"order_id"}),
				strmangle.WhereClause("\"", "\"", 2, redeemOrderGoalPrimaryKeyColumns),
			)
			values := []interface{}{o.ID, rel.ID}

			if boil.IsDebug(ctx) {
				writer := boil.DebugWriterFrom(ctx)
				fmt.Fprintln(writer, updateQuery)
				fmt.Fprintln(writer, values)
			}
			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			queries.Assign(&rel.OrderID, o.ID)
		}
	}

	if o.R == nil {
		o.R = &orderGoalR{
			OrderRedeemOrderGoals: related,
		}
	} else {
		o.R.OrderRedeemOrderGoals = append(o.R.OrderRedeemOrderGoals, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &redeemOrderGoalR{
				Order: o,
			}
		} else {
			rel.R.Order = o
		}
	}
	return nil
}

// SetOrderRedeemOrderGoals removes all previously related items of the
// order_goal replacing them completely with the passed
// in related items, optionally inserting them as new records.
// Sets o.R.Order's OrderRedeemOrderGoals accordingly.
// Replaces o.R.OrderRedeemOrderGoals with related.
// Sets related.R.Order's OrderRedeemOrderGoals accordingly.
func (o *OrderGoal) SetOrderRedeemOrderGoals(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*RedeemOrderGoal) error {
	query := "update \"redeem_order_goal\" set \"order_id\" = null where \"order_id\" = $1"
	values := []interface{}{o.ID}
	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, query)
		fmt.Fprintln(writer, values)
	}
	_, err := exec.ExecContext(ctx, query, values...)
	if err != nil {
		return errors.Wrap(err, "failed to remove relationships before set")
	}

	if o.R != nil {
		for _, rel := range o.R.OrderRedeemOrderGoals {
			queries.SetScanner(&rel.OrderID, nil)
			if rel.R == nil {
				continue
			}

			rel.R.Order = nil
		}
		o.R.OrderRedeemOrderGoals = nil
	}

	return o.AddOrderRedeemOrderGoals(ctx, exec, insert, related...)
}

// RemoveOrderRedeemOrderGoals relationships from objects passed in.
// Removes related items from R.OrderRedeemOrderGoals (uses pointer comparison, removal does not keep order)
// Sets related.R.Order.
func (o *OrderGoal) RemoveOrderRedeemOrderGoals(ctx context.Context, exec boil.ContextExecutor, related ...*RedeemOrderGoal) error {
	if len(related) == 0 {
		return nil
	}

	var err error
	for _, rel := range related {
		queries.SetScanner(&rel.OrderID, nil)
		if rel.R != nil {
			rel.R.Order = nil
		}
		if _, err = rel.Update(ctx, exec, boil.Whitelist("order_id")); err != nil {
			return err
		}
	}
	if o.R == nil {
		return nil
	}

	for _, rel := range related {
		for i, ri := range o.R.OrderRedeemOrderGoals {
			if rel != ri {
				continue
			}

			ln := len(o.R.OrderRedeemOrderGoals)
			if ln > 1 && i < ln-1 {
				o.R.OrderRedeemOrderGoals[i] = o.R.OrderRedeemOrderGoals[ln-1]
			}
			o.R.OrderRedeemOrderGoals = o.R.OrderRedeemOrderGoals[:ln-1]
			break
		}
	}

	return nil
}

// OrderGoals retrieves all the records using an executor.
func OrderGoals(mods ...qm.QueryMod) orderGoalQuery {
	mods = append(mods, qm.From("\"order_goal\""))
	q := NewQuery(mods...)
	if len(queries.GetSelect(q)) == 0 {
		queries.SetSelect(q, []string{"\"order_goal\".*"})
	}

	return orderGoalQuery{q}
}

// FindOrderGoal retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindOrderGoal(ctx context.Context, exec boil.ContextExecutor, iD int64, selectCols ...string) (*OrderGoal, error) {
	orderGoalObj := &OrderGoal{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"order_goal\" where \"id\"=$1", sel,
	)

	q := queries.Raw(query, iD)

	err := q.Bind(ctx, exec, orderGoalObj)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: unable to select from order_goal")
	}

	if err = orderGoalObj.doAfterSelectHooks(ctx, exec); err != nil {
		return orderGoalObj, err
	}

	return orderGoalObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *OrderGoal) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("models: no order_goal provided for insertion")
	}

	var err error
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		if o.UpdatedAt.IsZero() {
			o.UpdatedAt = currTime
		}
	}

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(orderGoalColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	orderGoalInsertCacheMut.RLock()
	cache, cached := orderGoalInsertCache[key]
	orderGoalInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			orderGoalAllColumns,
			orderGoalColumnsWithDefault,
			orderGoalColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(orderGoalType, orderGoalMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(orderGoalType, orderGoalMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"order_goal\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"order_goal\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "models: unable to insert into order_goal")
	}

	if !cached {
		orderGoalInsertCacheMut.Lock()
		orderGoalInsertCache[key] = cache
		orderGoalInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the OrderGoal.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *OrderGoal) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		o.UpdatedAt = currTime
	}

	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	orderGoalUpdateCacheMut.RLock()
	cache, cached := orderGoalUpdateCache[key]
	orderGoalUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			orderGoalAllColumns,
			orderGoalPrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("models: unable to update order_goal, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"order_goal\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, orderGoalPrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(orderGoalType, orderGoalMapping, append(wl, orderGoalPrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, values)
	}
	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update order_goal row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by update for order_goal")
	}

	if !cached {
		orderGoalUpdateCacheMut.Lock()
		orderGoalUpdateCache[key] = cache
		orderGoalUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q orderGoalQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all for order_goal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected for order_goal")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o OrderGoalSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("models: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), orderGoalPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"order_goal\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, orderGoalPrimaryKeyColumns, len(o)))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all in orderGoal slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected all in update all orderGoal")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *OrderGoal) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("models: no order_goal provided for upsert")
	}
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		o.UpdatedAt = currTime
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(orderGoalColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	orderGoalUpsertCacheMut.RLock()
	cache, cached := orderGoalUpsertCache[key]
	orderGoalUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			orderGoalAllColumns,
			orderGoalColumnsWithDefault,
			orderGoalColumnsWithoutDefault,
			nzDefaults,
		)

		update := updateColumns.UpdateColumnSet(
			orderGoalAllColumns,
			orderGoalPrimaryKeyColumns,
		)

		if updateOnConflict && len(update) == 0 {
			return errors.New("models: unable to upsert order_goal, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(orderGoalPrimaryKeyColumns))
			copy(conflict, orderGoalPrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"order_goal\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(orderGoalType, orderGoalMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(orderGoalType, orderGoalMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}
	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if errors.Is(err, sql.ErrNoRows) {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "models: unable to upsert order_goal")
	}

	if !cached {
		orderGoalUpsertCacheMut.Lock()
		orderGoalUpsertCache[key] = cache
		orderGoalUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single OrderGoal record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *OrderGoal) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("models: no OrderGoal provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), orderGoalPrimaryKeyMapping)
	sql := "DELETE FROM \"order_goal\" WHERE \"id\"=$1"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete from order_goal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by delete for order_goal")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q orderGoalQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("models: no orderGoalQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from order_goal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for order_goal")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o OrderGoalSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(orderGoalBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), orderGoalPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"order_goal\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, orderGoalPrimaryKeyColumns, len(o))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from orderGoal slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for order_goal")
	}

	if len(orderGoalAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *OrderGoal) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindOrderGoal(ctx, exec, o.ID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *OrderGoalSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := OrderGoalSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), orderGoalPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"order_goal\".* FROM \"order_goal\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, orderGoalPrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "models: unable to reload all in OrderGoalSlice")
	}

	*o = slice

	return nil
}

// OrderGoalExists checks if the OrderGoal row exists.
func OrderGoalExists(ctx context.Context, exec boil.ContextExecutor, iD int64) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"order_goal\" where \"id\"=$1 limit 1)"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, iD)
	}
	row := exec.QueryRowContext(ctx, sql, iD)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "models: unable to check if order_goal exists")
	}

	return exists, nil
}

// Exists checks if the OrderGoal row exists.
func (o *OrderGoal) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	return OrderGoalExists(ctx, exec, o.ID)
}
